/*
 * types.c
 * 
 * Copyright (c) 2000, BindView Corporation.
 *
 * See LICENSE file.
 *
 */


#include "syscalls.h"
#include "../driver/ioctlcmd.h"
#include <stdio.h>

#define MagicFoo(type) extern void copy_arg_##type (void *, DWORD);
#include "typesx.h"
#undef MagicFoo

struct type_info all_types[] = {
#define MagicFoo(type) { copy_arg_##type },
#include "typesx.h"
#undef MagicFoo
};


/*
 * define the copy functions for real, now
 */
void
copy_arg_DWORD (void *e, DWORD arg)
{
    ENTRY *ent = (ENTRY *)e;
    unsigned int *pbytes_used = (unsigned int *) arg;

    if (ent->args_size >= *pbytes_used + 4) {
        printf ("%d, ", ent->args[*pbytes_used/4]);
        *pbytes_used += 4;
    }
}

/*
 * define the copy functions for real, now
 */
void
copy_arg_PDWORD (void *e, DWORD arg)
{
    ENTRY *ent = (ENTRY *)e;
    unsigned int *pbytes_used = (unsigned int *) arg;

    if (ent->args_size >= *pbytes_used + 8) {
        if (ent->args[*pbytes_used/4] == 0) {
            printf ("%d, ", ent->args[*pbytes_used/4 + 1]);
        } else {
            printf ("0x%x, ", ent->args[*pbytes_used/4 + 1]);
        }
        *pbytes_used += 8;
    }
}


/*
 * define the copy functions for real, now
 */
void
copy_arg_HANDLE (void *e, DWORD arg)
{
    ENTRY *ent = (ENTRY *)e;
    unsigned int *pbytes_used = (unsigned int *) arg;

    if (ent->args_size >= *pbytes_used + 4) {
        printf ("%d, ", ent->args[*pbytes_used/4]);
        *pbytes_used += 4;
    }
}

/*
 * define the copy functions for real, now
 */
void
copy_arg_PHANDLE (void *e, DWORD arg)
{
    ENTRY *ent = (ENTRY *)e;
    unsigned int *pbytes_used = (unsigned int *) arg;

    if (ent->args_size >= *pbytes_used + 8) {
        if (ent->args[*pbytes_used/4] == 0) {
            printf ("%d, ", ent->args[*pbytes_used/4 + 1]);
        } else {
            printf ("0x%x, ", ent->args[*pbytes_used/4 + 1]);
        }
        *pbytes_used += 8;
    }
}


void
copy_arg_POBJ_ATTRIB (void *e, DWORD arg)
{
    ENTRY *ent = (ENTRY *)e;
    unsigned int *pbytes_used = (unsigned int *) arg;
    unsigned int len;

    if (ent->args_size >= *pbytes_used + 8) {
        if (ent->args[*pbytes_used/4] == -1) {
            printf ("0x%x, ", ent->args[*pbytes_used/4 + 1]);
            *pbytes_used += 8;
        } else {
            *pbytes_used += 4;
            printf ("{%d, %d, 0x%x, %d, %d, ",
                    ent->args[*pbytes_used/4],
                    ent->args[*pbytes_used/4+1],
                    ent->args[*pbytes_used/4+3],
                    ent->args[*pbytes_used/4+4],
                    ent->args[*pbytes_used/4+5]);
            *pbytes_used += 0x18;

            if (ent->args[*pbytes_used/4] == -1) {
                printf ("0x%x", ent->args[*pbytes_used/4 + 1]);
                *pbytes_used += 8;
            } else {
                *pbytes_used += 4;
                len = *(unsigned short *)(&ent->args[*pbytes_used/4]);
                *pbytes_used += 8;

                if (ent->args[*pbytes_used/4] == -1) {
                    printf ("0x%x, ", ent->args[*pbytes_used/4 + 1]);
                    *pbytes_used += 8;
                } else {
                    *pbytes_used += 4;
                    wprintf (L"\"%s\"", &ent->args[*pbytes_used/4]);
                    if (((unsigned short *)(&ent->args[*pbytes_used/4]))[len/2-1] != 0) {
                        len += 2;
                    }
                    *pbytes_used += ((len +3) / 4) * 4;
                }
            }
            printf ("}, ");
        }
    }
}



void
copy_arg_PUNICODE_STRING (void *e, DWORD arg)
{
    ENTRY *ent = (ENTRY *)e;
    unsigned int *pbytes_used = (unsigned int *) arg;
    unsigned int len;

    if (ent->args[*pbytes_used/4] == -1) {
        printf ("0x%x, ", ent->args[*pbytes_used/4 + 1]);
        *pbytes_used += 8;
    } else {
        *pbytes_used += 4;
        len = *(unsigned short *)(&ent->args[*pbytes_used/4]);
        *pbytes_used += 8;

        if (ent->args[*pbytes_used/4] == -1) {
            printf ("0x%x, ", ent->args[*pbytes_used/4 + 1]);
            *pbytes_used += 8;
        } else {
            *pbytes_used += 4;
            wprintf (L"\"%s\", ", &ent->args[*pbytes_used/4]);
            if (((unsigned short *)(&ent->args[*pbytes_used/4]))[(len-1)/2] != 0) {
                len += 2;
            }
            *pbytes_used += ((len +3) / 4) * 4;
        }
    }
}

void
copy_arg_ACCESS_MASK (void *e, DWORD arg)
{
    ENTRY *ent = (ENTRY *)e;
    unsigned int *pbytes_used = (unsigned int *) arg;

    if (ent->args_size >= *pbytes_used + 4) {
        printf ("0x%x, ", ent->args[*pbytes_used/4]);
        *pbytes_used += 4;
    }
}

void
copy_arg_PCLIENT_ID (void *e, DWORD arg)
{
    ENTRY *ent = (ENTRY *)e;
    unsigned int *pbytes_used = (unsigned int *) arg;

    if (ent->args[*pbytes_used/4] == -1) {
        printf ("0x%x, ", ent->args[*pbytes_used/4 + 1]);
        *pbytes_used += 8;
    } else {
        *pbytes_used += 4;
        printf ("{%d, %d}, ",
                ent->args[*pbytes_used/4],
                ent->args[*pbytes_used/4+1]);
        *pbytes_used += 8;
    }
}


void
copy_arg_PLPC_MESSAGE (void *e, DWORD arg)
{
    ENTRY *ent = (ENTRY *)e;
    unsigned int *pbytes_used = (unsigned int *) arg;
    struct foo {
        unsigned short len;
        unsigned short tot_len;
        unsigned long msg_typ;
        unsigned long pid;
        unsigned long tid;
        unsigned long mid;
        unsigned long sctn_sz;
    } *pmsg;

    if (ent->args[*pbytes_used/4] == -1) {
        printf ("0x%x, ", ent->args[*pbytes_used/4 + 1]);
        *pbytes_used += 8;
    } else {
        *pbytes_used += 4;
        pmsg = (struct foo *) &(ent->args[*pbytes_used/4]);
        printf ("{%d, %d, %d, %d, %d, %d, %d}, ",
                pmsg->len,
                pmsg->tot_len,
                pmsg->msg_typ,
                pmsg->pid,
                pmsg->tid,
                pmsg->mid,
                pmsg->sctn_sz);
        *pbytes_used += sizeof (*pmsg);
    }
}

void
copy_arg_PLPC_SECTIONINFO (void *e, DWORD arg)
{
    ENTRY *ent = (ENTRY *)e;
    unsigned int *pbytes_used = (unsigned int *) arg;
    struct foo {
        unsigned long len;
        unsigned long handle;
        unsigned long hmmm1;
        unsigned long sz;
        unsigned long cli_addr;
        unsigned long srv_addr;
    } *pmsg;

    if (ent->args[*pbytes_used/4] == -1) {
        printf ("0x%x, ", ent->args[*pbytes_used/4 + 1]);
        *pbytes_used += 8;
    } else {
        *pbytes_used += 4;
        pmsg = (struct foo *) &(ent->args[*pbytes_used/4]);
        printf ("{%d, %d, %d, %d, %d, %d}, ",
                pmsg->len,
                pmsg->handle,
                pmsg->hmmm1,
                pmsg->sz,
                pmsg->cli_addr,
                pmsg->srv_addr);
        *pbytes_used += sizeof (*pmsg);
    }
}

void
copy_arg_PLPC_SECTIONMAPINFO (void *e, DWORD arg)
{
    ENTRY *ent = (ENTRY *)e;
    unsigned int *pbytes_used = (unsigned int *) arg;
    struct foo {
        unsigned long len;
        unsigned long sz;
        unsigned long srv_addr;
    } *pmsg;

    if (ent->args[*pbytes_used/4] == -1) {
        printf ("0x%x, ", ent->args[*pbytes_used/4 + 1]);
        *pbytes_used += 8;
    } else {
        *pbytes_used += 4;
        pmsg = (struct foo *) &(ent->args[*pbytes_used/4]);
        printf ("{%d, %d, %d}, ",
                pmsg->len,
                pmsg->sz,
                pmsg->srv_addr);
        *pbytes_used += sizeof (*pmsg);
    }
}


#if 0
void
copy_arg_POBJ_ATTRIB (void *e, DWORD arg)
{
    ENTRY *ent = (ENTRY *)e;
    unsigned int *pbytes_used = (unsigned int *) arg;
    unsigned int arg_size;

    if (ent->args_size >= *pbytes_used + 4) {
        arg_size = ent->args[*pbytes_used/4];
        
        if (arg_size == 4) {
            /* pObj was null */
            printf ("<null>, ");
        } else {
            printf ("{%d, %d,", ent->args[*pbytes_used/4 + 1], ent->args[*pbytes_used/4 + 2]);
            wprintf (L" %s", &ent->args[*pbytes_used/4 + 3]);
            printf ("}");
        }
        *pbytes_used += arg_size;
    }
}

#endif
