/*
 * syscalls.h
 * 
 * Copyright (c) 2000, BindView Corporation.
 *
 * See LICENSE file.
 *
 * System call definitions.  Shared by kernel and user sides.
 *
 */

#ifndef SYSCALL_H
#define SYSCALL_H

typedef unsigned long DWORD;
/*
 * The calls for our purposes. (based on NT 4 SP4)
 *
 * Note that this is not necessarily the order that these appear in
 * the kernel's service table.  This is just for identifying kernel calls
 * within strace itself.
 */
#define MagicFoo(call,args) call##_##args,
enum syscall {
#include "syscallx.h"
};
#undef MagicFoo


#define DIR_IN      0
#define DIR_OUT     1
#define DIR_IN_OUT  2  /* used ? */


struct single_arg {
    int type;
    int dir;
};


struct arg_info {
    int num;
    struct single_arg args[20];   /* big enough ? */
};

struct syscall_props {
    enum syscall num;
    char *       name;
    void *       hook;
    void *       real;
    struct arg_info *arg_info;
};

/*
 * kernel version specific mappings
 */
struct syscall_map {
    enum syscall fn;
    void *hook;
};

struct type_info {
    void (*copy_arg)(void *, DWORD);
};

extern struct type_info all_types[];

extern struct arg_info *all_arg_info[];

extern struct syscall_props all_syscalls[];

extern struct syscall_map nt4sp4_map[];
extern unsigned int nt4sp4_map_size;
extern struct syscall_map nt5_map[];
extern unsigned int nt5_map_size;
extern struct syscall_map nt4sp45_win32k_map[];
extern unsigned int nt4sp45_win32k_map_size;
extern struct syscall_map nt4sp6_win32k_map[];
extern unsigned int nt4sp6_win32k_map_size;
extern struct syscall_map nt5_win32k_map[];
extern unsigned int nt5_win32k_map_size;

extern void calc_map_sizes ();
extern void init_arg_info (void);

#endif
